% This code if for the book titled: Advanced Digital Signal Processing 
% of Seismic Data by Wail A. Mousa 
% January 1, 2020.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%% Chapter 1 MATLAB codes %%%
%%% Figure 1.12 Convolution seismic data model %%
clear,clc,close all
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
n=[0:25];
x=zeros(1,length(n));
x(n==0)=1;
figure
stem(n,x,'k','fill','LineWidth',5)
ylabel('{\it\delta}[{\it n}]','FontName','Times','FontSize',18)
xlabel('\it n','FontName','Times','FontSize',18)
axis([-1,26,-1.5,1.5])
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
n=[0:25];
r=zeros(1,length(n));
r(n==7)=0.45;
r(n==14)=-0.75;
r(n==21)=-0.39;
r(n==25)=0.3;
figure,
stem(n,r,'k','fill','LineWidth',5)
xlabel('\it n','FontName','Times','FontSize',18)
ylabel('{\it r}[{\it n}]','FontName','Times','FontSize',18)
axis([-1,26,-1.5,1.5])
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
n=[0:25];
x=zeros(1,length(n));
x(n==0)=-0.5;
x(n==1)=1;
x(n==2)=-0.5;
figure
stem(n,x,'k','fill','LineWidth',5)
ylabel('{\it w}[{\it n}]','FontName','Times','FontSize',18)
xlabel('\it n','FontName','Times','FontSize',18)
axis([-1,26,-1.5,1.5])
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
n=[0:29];
g=conv(x,r);
figure,
stem(n,g([1:30]),'k','fill','LineWidth',5)
xlabel('\it n','FontName','Times','FontSize',18)
ylabel('{\it g}[{\it n}]','FontName','Times','FontSize',18)
axis([-1,30,-1.5,1.5])
legend('{\it w}[{\it n}]*{\it r}[{\it n}]','')
figure,
stem(n,g([1:30]),'Color',[0.5,0.5,0.5],'LineStyle','-.','Marker','square','LineWidth',3,'MarkerSize',3,'MarkerFaceColor',[0.5,0.5,0.5],'MarkerEdgeColor',[0.5,0.5,0.5])
hold on
stem(n,[g([1:30])+0.1*randn(1,30)],'k','fill')
hold off
xlabel('\it n','FontName','Times','FontSize',18)
ylabel('{\it g}[{\it n}]','FontName','Times','FontSize',18)
legend('{\it w}[{\it n}]*{\it r}[{\it n}]','{\it w}[{\it n}]*{\it r}[{\it n}]+{\it n_r}[{\it n}]')
axis([-1,30,-1.5,1.5])


