% This code if for the book titled: Advanced Digital Signal Processing 
% of Seismic Data by Wail A. Mousa 
% January 1, 2020.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%% Chapter 1 MATLAB codes %%%
%%% Figure 1.7 Vibroseis signature signal%%
clear,clc,close all
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Plotting the geophone impulse response
t=linspace(0,1,512);
h1=7.5443E6*exp(-21*t).*cos(27.55*t-0.625);
figure,plot(t,h1,'k','LineWidth',2)
ylabel('{\it{h}}({\it{t}})','FontName','Times','FontSize',14)
xlabel('Time(s)','FontName','Times','FontSize',14)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Plotting its frequency response
maxf=500;
w=linspace(-maxf,maxf,512);
H=(j*6E5*w)./(-w.^2+j*42*w+1200);
figure, plot(w,abs(H),'k','LineWidth',2)
axis tight
xlabel('Frequency(Hz)','FontName','Times','FontSize',14)
ylabel('|{\it{H}}({\it{f}})|','FontName','Times','FontSize',14)
figure, plot(w,angle(H),'k','LineWidth',2)
axis tight
xlabel('Frequency(Hz)','FontName','Times','FontSize',14)
ylabel('\angle{{\it{H}}({\it{f}})} (rad)','FontName','Times','FontSize',14)

